var $ = jQuery;

$(document).ready(() => {
  addAnimationSpecialClasses();
  changeContactForm7ClassesToSupportSkit();
  addNavColours();
  separateTopLevelPages();
  unwrapIconsFromP();
  addContentBlockToCCChild();
  footerAccordion();
  fitContentBlocksToSkit();
  removeContentTextWidthFromCertainPages();
  addH4SubtitleInEntry();
  removeLocationImagesWithNoSRCOnSchedule();
  setIcal();
  wpGallery();
  choseDarkBG();
});

$(document).on('nfFormReady', () => {
  changeNFClassesToSupportSkit();
  trackNFChanges();
});

function navWalkerDropdown() {
  $('.sk-dropdown-container > a').addClass('sk-dropdown');
}

function removeLocationImagesWithNoSRCOnSchedule() {
  $(".sk-schedule img[src='']").detach();
}

function addH4SubtitleInEntry() {
  var $title = $('.entry-content .entry-title');
  $sibling = $title.next();
  if ($sibling.is('h4')) {
    $title.append($sibling);
  }
}

function wpGallery() {
  $('.gallery').addClass('sk-gallery grid caption');
  $('.gallery-item').addClass('sk-gallery-item');
  $('.gallery-caption').addClass('sk-gallery-item-caption');
  $('.gallery-icon').addClass('sk-gallery-image');
}

function removeContentTextWidthFromCertainPages() {
  $('.no-padding-parent')
    .parent()
    .addClass('no-padding')
    .removeClass('content-text-width');
}

function fitContentBlocksToSkit() {
  var contentBlocks = $('.sk-tiles > a');
  contentBlocks.each((index, contentBlock) => {
    var $contentBlock = $(contentBlock);
    $contentBlock.addClass('sk-tile');

    if (!$contentBlock.find('.sk-tile-top').length) {
      var $top = $('<div>').addClass('sk-tile-top');
      $top.append('<div class="sk-tile-top-image"></div>');
      $contentBlock.find('.sk-tile-top-text').appendTo($top);

      var $imageDiv = $top.find('.sk-tile-top-image');
      var $image = $contentBlock.find('img');
      $imageDiv.css('background-image', 'url(' + $image.attr('src') + ')');
      $image.remove();

      //add support for legacy content_blocks
      $contentBlock
        .find('.content-block-text')
        .removeClass('content-block-text')
        .addClass('sk-tile-top-text')
        .appendTo($top);
      var $tileTitleH3 = $contentBlock.find('h3');
      $tileTitleH3.replaceWith($('<h4>' + $tileTitleH3.html() + '</h4>'));
      $contentBlock.find('h4').addClass('sk-tile-title');

      $contentBlock.prepend($top);
    }
  });
}

function footerAccordion() {
  var $accordion = $('footer .menu-item-has-children');
  $accordion.addClass('sk-accordion-super');

  var $title = $accordion.find('> a');
  $title.wrapInner('<h4 />');
  $title.wrap('<div class="sk-accordion-title" />');
  $('<i></i>').appendTo($title.parent());

  var $content = $accordion.find('.sub-menu');
  $content.wrap('<div class="sk-accordion-content" />');
}

function addContentBlockToCCChild() {
  $('.ccchildpages').removeClass('ccchildpages');
  var $ccchilds = $('.ccchildpage');
  $ccchilds.find('.ccpage_linked_thumb').addClass('sk-tile');

  $ccchilds.each(function(index, child) {
    var $child = $(child);
    $link = $child.find('a');
    $heading = $child.find('h3');
    $heading.appendTo($link);

    $link.find('h3');
    $child.find('.ccpage_linked_thumb').unwrap();
  });
}

function unwrapIconsFromP() {
  $('p:has(i) i').unwrap();
}

function addAnimationSpecialClasses() {
  setTimeout(() => {
    $('.moon').addClass('fadeInOut');
  }, 3000);
}

function changeNFClassesToSupportSkit() {
  $('.nf-field-element').addClass('sk-form-item');

  $(".nf-field-element input[type='button']").addClass('sk-button nav-colour');
  $('.nf-fu-fileinput-button').addClass('sk-button nav-colour dark');
  $(".nf-mp-footer input[type='button']").addClass('sk-button nav-colour');

  $(':file.nf-element').addClass('ignore');

  $('nf-fu-progress').addClass('sk-progress');
  $('nf-fu-progress-bar').addClass('sk-progress-bar');

  var $checkboxContainers = $('.field-wrap.checkbox-wrap');
  $checkboxContainers.each((index, container) => {
    const $container = $(container);
    var $fieldContainer = $container.find('.sk-form-item');
    $fieldContainer.removeClass('nf-field-element');
    $container.find('.nf-field-label label').appendTo($fieldContainer);
  });
}

function choseDarkBG() {
  var $decoLeft = $('.left-deco');
  var $decoRight = $('.right-deco');
  var $smokeLeft = $('.left-smoke');
  var $bg = $('.sk-fixed-bg-inner');
  var $moon = $('.moon');
  var currentTime = new Date().getHours();

  var sunsetHour = 20;
  var sunriseHour = 06;

  if (
    !$decoLeft.length ||
    !$decoRight.length ||
    !$moon.length ||
    !$bg.length ||
    !$smokeLeft.length
  ) {
    return;
  }

  if (currentTime <= sunriseHour || currentTime >= sunsetHour) {
    $bg.addClass('dark');
    $decoLeft.attr('src', $decoLeft.attr('src').replace('light', 'dark'));
    $decoRight.attr('src', $decoRight.attr('src').replace('light', 'dark'));
    $smokeLeft.attr('src', $smokeLeft.attr('src').replace('light', 'dark'));
    $moon.attr('src', $moon.attr('src').replace('light', 'dark'));
  }
}

function trackNFChanges() {
  var config = { childList: true, subtree: true };
  var observer = new MutationObserver((mutationsList) => {
    changeNFClassesToSupportSkit();
    trackNFChanges();
    observer.disconnect();
  });
  observer.observe($('nf-field')[0], config);
}

function changeContactForm7ClassesToSupportSkit() {
  $('.wpcf7-response-output').addClass('sk-flag-message');
  $('.wpcf7').on('wpcf7:invalid', function(event) {
    $('.wpcf7-validation-errors')
      .addClass('error')
      .removeClass('wpcf7-validation-errors');

    $('.wpcf7-not-valid-tip').addClass('error');

    $('.wpcf7-not-valid')
      .addClass('error')
      .removeClass('wpcf7-not-valid');
  });

  $('.wpcf7').on('wpcf7:submit', function(event) {
    $('.wpcf7-mail-sent-ok')
      .addClass('success')
      .removeClass('wpcf7-mail-sent-ok');
  });

  $('.wpcf7-submit').addClass('sk-button nav-colour');
}

function addNavColours() {
  $('.type-event')
    .parents('body')
    .addClass('top-parent-38'); //makes the Events Pod acquire the styles of Whats On

  addColour(38, 'nav-colour-konata', 'top-parent'); // Whats On
  addColour(36, 'nav-colour-konata', 'top-parent'); // Plan Your Day
  addColour(40, 'nav-colour-konata', 'top-parent'); // Get Involved
  addColour(18, 'nav-colour-konata', 'top-parent'); // Contact

  addColour(3923, 'nav-colour-miku', 'sub-parent', true); // Things To Do + children
  addColour(3926, 'nav-colour-yoko', 'sub-parent', true); // Things To See + children
  addColour(84, 'nav-colour-taiga', 'sub-parent', true); //  Events To Attend + children
  addColour(76, 'nav-colour-c2', 'sub-parent', true); //  Guests + children

  addColour(17, 'nav-colour-sakura', 'sub-parent', true); //  About + children

  addColour(4372, 'bg-colour-konata dark', 'top-parent', false, true); // Anisong

  if (/joinus/.test(window.location.href)) {
    $('body').addClass('nav-colour-shinobu');
  }
}

function separateTopLevelPages() {
  addTopLevelClass(16); // Home
  addTopLevelClass(38); // Whats on
  addTopLevelClass(36); // Plan Your Day
  addTopLevelClass(40); // Get Involved
  addTopLevelClass(18); // Contact
}

function addTopLevelClass(postId) {
  $('#post-' + postId).addClass('top-level');
}

function addColour(pageId, cssClassToAdd, type, overrideColor = false, isDarkMode = false) {
  var $element = $('.' + type + '-' + pageId);

  if (overrideColor) {
    $element.removeClass(function(index, className) {
      return (className.match(/(^|\s)nav-colour-\S+/g) || []).join(' ');
    });
  }

  $element.addClass(cssClassToAdd);

  if (isDarkMode) {
    $element.find('header nav').addClass(cssClassToAdd);
    $element.find('header .nav-special-arrow').addClass(cssClassToAdd);    
    $element.find('header .hamburger-menu').addClass(cssClassToAdd);
    $element.find('header .sk-dropdown-list').addClass(cssClassToAdd);
    $element
      .find('header #header-home-logo')
      .attr('src', 'https://skit.smash.org.au/images/logo_inverted.svg');
    $element
      .find('header #header-anisong-logo')
      .attr('src', 'https://skit.smash.org.au/images/anisong_logo_white.png');
  }
}

function setIcal() {
  // Since the add to calendar is inside an anchor, prevent it and call the custom event instead
  $('.sk-schedule').click(function(e) {
    if ($(e.target).hasClass('sk-schedule-event-calendar-add')) {
      e.preventDefault();
      addIcal($(e.target));
    } else if ($(e.target).hasClass('i-calendar-plus-o')) {
      e.preventDefault();
      addIcal($(e.target).parent());
    }
  });
}

function addIcal(event) {
  location.href = $(event).attr('data-link');
}
